"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.storage = exports.Storage = exports.PropertyInfo = void 0;
/* eslint-disable @typescript-eslint/no-non-null-assertion */
/* eslint-disable @typescript-eslint/ban-types */
const ArrayMemberExistsError_1 = require("./exceptions/ArrayMemberExistsError");
class PropertyInfo {
    constructor(key, options) {
        this.key = '';
        this.key = key;
        this.options = options;
    }
}
exports.PropertyInfo = PropertyInfo;
class Storage {
    constructor() {
        this.map = new Map();
    }
    add(constructor, index, info) {
        if (!this.map.has(constructor)) {
            this.map.set(constructor, new Map());
        }
        const indexMap = this.map.get(constructor);
        if (indexMap.has(index)) {
            const oldInfo = indexMap.get(index);
            throw new ArrayMemberExistsError_1.ArrayMemberExistsError(`ArrayMember ${index} exists in ${constructor.name}.${oldInfo.key}: should not override ${constructor.name}.${info.key}`);
        }
        indexMap.set(index, info);
        this.map.set(constructor, new Map([...indexMap.entries()].sort((a, b) => a[0] - b[0])));
    }
    has(constructor) {
        return this.map.has(constructor);
    }
    getPropertyIndexMap(constructor) {
        return this.map.get(constructor);
    }
}
exports.Storage = Storage;
exports.storage = new Storage();
//# sourceMappingURL=storage.js.map