"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const mocha_1 = require("@testdeck/mocha");
const chai_1 = require("chai");
const common_errors_1 = require("common-errors");
const src_1 = require("../../src");
const ArrayMemberExistsError_1 = require("../../src/exceptions/ArrayMemberExistsError");
class TestClass {
    constructor() {
        this.test1 = '';
        this.test2 = '';
    }
}
class TestDuplicatedClass {
    constructor() {
        this.test1 = '';
        this.test2 = '';
    }
}
let ArrayMemberTest = 
// eslint-disable-next-line @typescript-eslint/no-unused-vars
class ArrayMemberTest {
    normal() {
        chai_1.expect(() => src_1.ArrayMember(0)(Object.create(TestClass.prototype), 'test1')).not.throw();
        chai_1.expect(() => src_1.ArrayMember(1)(Object.create(TestClass.prototype), 'test2')).not.throw();
    }
    typeError() {
        chai_1.expect(() => src_1.ArrayMember('')).throw(common_errors_1.TypeError);
        chai_1.expect(() => src_1.ArrayMember(true)).throw(common_errors_1.TypeError);
        chai_1.expect(() => src_1.ArrayMember({})).throw(common_errors_1.TypeError);
    }
    duplicateIndex() {
        const func = src_1.ArrayMember(0);
        chai_1.expect(() => func(Object.create(TestDuplicatedClass.prototype), 'test1')).not.throw();
        chai_1.expect(() => func(Object.create(TestDuplicatedClass.prototype), 'test2')).throw(ArrayMemberExistsError_1.ArrayMemberExistsError);
    }
};
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ArrayMemberTest.prototype, "normal", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ArrayMemberTest.prototype, "typeError", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ArrayMemberTest.prototype, "duplicateIndex", null);
ArrayMemberTest = __decorate([
    mocha_1.suite()
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
], ArrayMemberTest);
//# sourceMappingURL=ArrayMember.test.js.map