"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const mocha_1 = require("@testdeck/mocha");
const src_1 = require("../src");
const Product_1 = require("./classes/Product");
const factories_1 = require("./factories");
const validate_1 = require("./factories/validate");
/* eslint-disable @typescript-eslint/no-non-null-assertion */
let PlainArrayToClassTest = 
// eslint-disable-next-line @typescript-eslint/no-unused-vars
class PlainArrayToClassTest {
    async normal() {
        const expected = factories_1.factory.make(Product_1.Product).one();
        validate_1.productValidate(expected, src_1.plainArrayToClass(Product_1.Product, [
            expected.id,
            expected.price,
            +expected.displayPrice,
            [expected.color.name],
            expected.sizes.map((p) => [p.size]),
            expected.values,
        ]));
    }
    async array() {
        const testData = factories_1.factory.make(Product_1.Product).many(2);
        const results = src_1.plainArrayToClass(Product_1.Product, testData.map((expected) => [
            expected.id,
            expected.price,
            +expected.displayPrice,
            [expected.color.name],
            expected.sizes.map((p) => [p.size]),
            expected.values,
        ]), { isArray: true });
        chai_1.expect(results).property('constructor', Array);
        chai_1.expect(results).length(testData.length);
        for (const [i, expected] of testData.entries()) {
            chai_1.expect(results).property(i.toString());
            validate_1.productValidate(expected, results[i]);
        }
    }
};
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], PlainArrayToClassTest.prototype, "normal", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], PlainArrayToClassTest.prototype, "array", null);
PlainArrayToClassTest = __decorate([
    mocha_1.suite()
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
], PlainArrayToClassTest);
//# sourceMappingURL=plainArrayToClass.test.js.map